-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

if cfg.release>6 then
lib.classes["MONK"] = {}
local t,s,n
lib.classpreload["MONK"] = function()
	lib.SetPower("ENERGY")
	lib.SetAltPower("CHI")
	cfg.cleave_threshold=3
end
lib.classes["MONK"][10] = function() --Brewmaster
	
	cfg.chi_hit=1
	cfg.talents={
		["CHI_EXPLOSION"]=IsPlayerSpell(157676), --Chi Explosion
		["RJW"]=IsPlayerSpell(116847) --Rushing Jade Wind
	}
	
	lib.AddSpell("Keg",{121253}) --Keg Smash
	lib.FixSpell("Keg","cost")
	lib.AddSpell("Haze",{115180}) --Dizzying Haze
	lib.AddSpell("Breath",{115181}) -- Breath of Fire
	lib.AddAura("Breath",123725,"debuff","target") -- Breath of Fire
	lib.AddSpell("Guard",{115295},true) -- Guard
	lib.AddAura("Shuffle",115307,"buff","player") -- Shuffle
	lib.SetTrackAura("Shuffle")
	--[[lib.SetAuraFunction("Shuffle","OnApply",function()
		lib.UpdateTrackAura(cfg.GUID["player"],0)
	end)
	lib.SetAuraFunction("Shuffle","OnFade",function()
		lib.UpdateTrackAura(cfg.GUID["player"])
	end)]]
	
	lib.AddSpell("Brew",{115308},true) -- Elusive Brew
	lib.AddAura("Brew_stacks",128939,"buff","player") -- Elusive Brew stacks
	lib.AddSpell("Purifying",{119582}) -- Purifying Brew
	lib.AddAuras("Stagger",{124274,124273},"debuff","player","player")
	
	lib.SetDOT("Breath")
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Touch of Death")
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"Detocs")
	table.insert(cfg.plistdps,"LotWT_nobuff")
	table.insert(cfg.plistdps,"Xuen")
	table.insert(cfg.plistdps,"Guard_noGuard")
	table.insert(cfg.plistdps,"Keg_nomax")
	table.insert(cfg.plistdps,"Expel_nomax")
	table.insert(cfg.plistdps,"Jab_nomax")
	table.insert(cfg.plistdps,"Serenity_buffed")
	if cfg.talents["CHI_EXPLOSION"] then
		table.insert(cfg.plistdps,"CE_Stagger")
	else
		table.insert(cfg.plistdps,"Purifying_Stagger")
	end
	table.insert(cfg.plistdps,"Kick_noShuffle")
	table.insert(cfg.plistdps,"Sphere_noSphere")
	table.insert(cfg.plistdps,"Brew_noBrew")
	table.insert(cfg.plistdps,"Tiger Palm_noPower")
	--
	--table.insert(cfg.plistdps,"Breath_noBreath")
	table.insert(cfg.plistdps,"Kick_3")
	table.insert(cfg.plistdps,"Chi-Wave")
	if IsPlayerSpell(117967) then
		table.insert(cfg.plistdps,"Tiger Palm")
	end
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Kick")
	table.insert(cfg.plistaoe,"Detocs")
	table.insert(cfg.plistaoe,"LotWT_nobuff")
	table.insert(cfg.plistaoe,"Keg_nomax")
	table.insert(cfg.plistaoe,"Spin_nomax")
	if cfg.talents["RJW"] then
		table.insert(cfg.plistaoe,"Expel_nomax")
		table.insert(cfg.plistaoe,"Jab_aoe")
	end
	if not cfg.talents["CHI_EXPLOSION"] then
		table.insert(cfg.plistaoe,"Purifying_Stagger")
	end
	table.insert(cfg.plistaoe,"Tiger Palm_noPower")
	table.insert(cfg.plistaoe,"Sphere_noSphere")
	table.insert(cfg.plistaoe,"Kick_noShuffle_aoe")
	table.insert(cfg.plistaoe,"Guard_noGuard")
	if cfg.talents["CHI_EXPLOSION"] then
		table.insert(cfg.plistaoe,"CE_aoe")
	else
		table.insert(cfg.plistaoe,"Breath_noBreath")
	end
	table.insert(cfg.plistaoe,"Brew_noBrew")
	table.insert(cfg.plistaoe,"Chi-Wave")
	if IsPlayerSpell(117967) then
		table.insert(cfg.plistaoe,"Tiger Palm")
	end
	table.insert(cfg.plistaoe,"end")
	
	cfg.plist=cfg.plistdps
	
	
	cfg.case = {
		["Guard_noGuard"] = function()
			if lib.GetUnitHealth("player","percent")>cfg.healpercent then return nil end
			return lib.SimpleCDCheck("Guard",lib.GetAura({"Guard"})-9)
		end,
		["Kick_noShuffle"] = function()
			if cfg.AltPower.now<2 then return nil end
			return lib.SimpleCDCheck("Kick",lib.GetAura({"Shuffle"})-1.8)
		end,
		["Kick_noShuffle_aoe"] = function()
			if cfg.AltPower.now<2 then return nil end
			return lib.SimpleCDCheck("Kick",lib.GetAura({"Shuffle"}))
		end,
		["Brew_noBrew"] = function()
			if lib.GetAuraStacks("Brew_stacks")>=9 then
				return lib.SimpleCDCheck("Brew",lib.GetAura({"Brew"}))
			end
			return nil
		end,
		["Breath_noBreath"] = function()
			return lib.SimpleCDCheck("Breath",lib.GetAura({"Breath"})-2.4)
		end,
		["Purifying_Stagger"] = function()
			if lib.GetAuras("Stagger")>0 then return lib.SimpleCDCheck("Purifying") end
			return nil
		end,
		["CE_Stagger"] = function()
			if cfg.AltPower.now>=3 and lib.GetAuras("Stagger")>0 then
				return lib.SimpleCDCheck("Kick")
			end
			return nil
		end,
		["Keg_nomax"] = function()
			if cfg.AltPower.max>=cfg.AltPower.now+2 then
				return lib.SimpleCDCheck("Keg")
			end
			return nil
		end,
		["Jab_nomax"] = function()
			if cfg.AltPower.max<cfg.AltPower.now+cfg.chi_hit+lib.GetAuraStacks("Power_Strikes") then
				return nil
			end
			if lib.GetSpellCD("Keg")>=lib.Time2Power(lib.GetSpellCost("Keg")+lib.GetSpellCost("Jab")-cfg.Power.regen) then
				return lib.SimpleCDCheck("Jab",lib.GetAura({"Serenity"}))
			end
			return nil
		end,
		["Jab_aoe"] = function()
			if cfg.AltPower.max<cfg.AltPower.now+cfg.chi_hit+lib.GetAuraStacks("Power_Strikes") then
				return nil
			end
			if lib.GetSpellCD("Spin")>=lib.Time2Power(lib.GetSpellCost("Spin")+lib.GetSpellCost("Jab")) then
				return lib.SimpleCDCheck("Jab")
			end
			return nil
		end,
		["Expel_nomax"] = function()
			if cfg.AltPower.max>=cfg.AltPower.now+cfg.chi_hit+lib.GetAuraStacks("Power_Strikes") and lib.GetUnitHealth("player","percent")<=cfg.healpercent then
				return lib.SimpleCDCheck("Expel")
			end
			return nil
		end
	}
	
	cfg.mode = "dps"
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
	end

	return true
end
lib.classes["MONK"][3] = function() --Windwalker
	cfg.MonitorSpells=true
	cfg.my_last_debug=""
	lib.LastCheckSpell=function(spell)
		if lib.IsLastSpell(spell) then
			--[[if cfg.my_last_debug~="DUP "..spell then
				cfg.my_last_debug="DUP "..spell
				print(cfg.my_last_debug)
			end]]
			return false
		else
			--[[if cfg.my_last_debug~=(cfg.lastspell.." "..cfg.lastspell_name) then
				cfg.my_last_debug=cfg.lastspell.." "..cfg.lastspell_name
				print(cfg.my_last_debug)
			end]]--
			return true			
		end
	end
	cfg.chi_hit=2
	cfg.talents={
		["Serenity"]=IsPlayerSpell(152173), --Chi Explosion
		["Rushing Jade Wind"]=IsPlayerSpell(116847),
		["Whirling Dragon Punch"]=IsPlayerSpell(152175),
		["Energizing Elixir"]=IsPlayerSpell(115288),
	}
	
	lib.AddSpell("Flying Serpent Kick",{101545})
	lib.AddSpell("Crackling Jade Thunderstorm",{117952},true)
	lib.AddSpell("Rising Sun Kick",{107428})
	lib.AddAura("Mark of the Crane",228287,"debuff","target")
	lib.AddAura("Blackout Kick!",116768,"buff","player")
	lib.AddSpell("Tiger Palm",{100780}) --Tiger Palm
	lib.FixSpell("Tiger Palm","cost")
	lib.AddSpell("Fists of Fury",{113656},nil,nil,true) -- Fists of Fury
	lib.AddSpell("Spinning Crane Kick",{101546},true)
	lib.AddSpell("Rushing Jade Wind",{116847},true)
	lib.AddSpell("Whirling Dragon Punch",{152175})
	lib.AddSpell("Energizing Elixir",{115288})
	lib.AddSpell("Strike of the Windlord",{205320})
	lib.AddSpell("Effuse",{116694})
	lib.NoSaveSpell("Effuse")
	cfg.heal=60
	if cfg.talents["Serenity"] then
		lib.AddSpell("Serenity",{152173},true)
		lib.NoSaveSpell("Serenity")
	else
		lib.AddSpell("Storm, Earth, and Fire",{137639},true)
		lib.NoSaveSpell("Storm, Earth, and Fire")
	end
	
	lib.AddAura("Hit Combo",196741,"buff","player")
	lib.SetTrackAura("Hit Combo")
	--[[lib.SetAuraFunction("Hit Combo","OnStacks",function()
		lib.UpdateTrackAura(cfg.GUID["player"],lib.GetAuraStacks("Hit Combo")>0 and lib.GetAuraStacks("Hit Combo") or nil)
	end)]]
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"Detocs")
	table.insert(cfg.plistdps,"heal")
	table.insert(cfg.plistdps,"Xuen")
	table.insert(cfg.plistdps,"Touch of Death")

	if cfg.talents["Serenity"] then
		table.insert(cfg.plistdps,"Serenity")
	else
		table.insert(cfg.plistdps,"Storm, Earth, and Fire")
	end
	if cfg.talents["Energizing Elixir"] then
		table.insert(cfg.plistdps,"Energizing Elixir")
	end
	if cfg.talents["Serenity"] and cfg.talents["Rushing Jade Wind"] then
		table.insert(cfg.plistdps,"Rushing Jade Wind_Serenity")
	end
	
	table.insert(cfg.plistdps,"Strike of the Windlord")
	if cfg.talents["Whirling Dragon Punch"] then
		table.insert(cfg.plistdps,"Whirling Dragon Punch_aoe")
	end
	table.insert(cfg.plistdps,"Fists of Fury")
	if cfg.talents["Whirling Dragon Punch"] then
		table.insert(cfg.plistdps,"Whirling Dragon Punch")
	end
	table.insert(cfg.plistdps,"Tiger Palm_nomax")
	if cfg.talents["Whirling Dragon Punch"] then
		table.insert(cfg.plistdps,"Rising Sun Kick_aoe")
	end
	table.insert(cfg.plistdps,"Rising Sun Kick_noaoe")
	table.insert(cfg.plistdps,"Rushing Jade Wind")
	table.insert(cfg.plistdps,"Spinning Crane Kick_aoe")
	table.insert(cfg.plistdps,"Blackout Kick")
	table.insert(cfg.plistdps,"Tiger Palm2")
	table.insert(cfg.plistdps,"Chi-Wave")
	table.insert(cfg.plistdps,"Chi Burst")
	table.insert(cfg.plistdps,"Crackling Jade Thunderstorm")
	table.insert(cfg.plistdps,"Flying Serpent Kick_aoe")
	table.insert(cfg.plistdps,"Tiger Palm")
	table.insert(cfg.plistdps,"Blackout Kick_max")
	if not cfg.talents["Rushing Jade Wind"] then
		table.insert(cfg.plistdps,"Blackout Kick_aoe")
	end
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Kick")
	table.insert(cfg.plistaoe,"Detocs")
	table.insert(cfg.plistaoe,"end")
	cfg.plistaoe=nil

	cfg.plist=cfg.plistdps

	cfg.case = {
		["heal"] = function()
			if lib.GetUnitHealth("player","percent")<=cfg.heal then
				return lib.SimpleCDCheck("Effuse")
			end
			return nil
		end,
		["Whirling Dragon Punch_aoe"] = function()
			if cfg.cleave_targets>=2 then
				return lib.SimpleCDCheck("Whirling Dragon Punch")
			end
			return nil
		end,
		["Serenity"] = function()
			if lib.GetSpellCD("Fists of Fury")>=lib.GetSpellCD("Serenity") and lib.GetSpellCD("Fists of Fury")<lib.GetSpellCD("Serenity")+8 then
				return lib.SimpleCDCheck("Serenity")
			end
			return nil
		end,
		["Spinning Crane Kick_aoe"] = function()
			if cfg.cleave_targets>=3 or lib.GetSpellCD("Spinning Crane Kick")<lib.GetAura({"Serenity"}) then
				return lib.SimpleCDCheck("Spinning Crane Kick")
			end
			return nil
		end,
		["Rising Sun Kick_noaoe"] = function()
			if cfg.cleave_targets<3 or cfg.noaoe then
				return lib.SimpleCDCheck("Rising Sun Kick")
			end
			return nil
		end,
		["Rising Sun Kick_aoe"] = function()
			if cfg.cleave_targets>=3 then
				if lib.GetSpellCD("Fists of Fury")>lib.GetSpellCD("Whirling Dragon Punch") and lib.GetSpellCD("Whirling Dragon Punch")<(lib.GetSpellCD("Rising Sun Kick")+lib.GetSpellFullCD("Rising Sun Kick")) then
					return lib.SimpleCDCheck("Rising Sun Kick")
				end
			end
			return nil
		end,
		
		["Energizing Elixir"] = function()
			if cfg.Power.now<cfg.Power.max and cfg.AltPower.now<=1 then
				return lib.SimpleCDCheck("Energizing Elixir",lib.GetAura({"Serenity"}))
			end
			return nil
		end,
		["Tiger Palm2"] = function()
			if cfg.AltPower.max-cfg.AltPower.now>=2+lib.GetAuraStacks("Power_Strikes") then
				return lib.SimpleCDCheck("Tiger Palm",lib.GetAura({"Serenity"}))
			end
			return nil
		end,
		["Tiger Palm"] = function()
			return lib.SimpleCDCheck("Tiger Palm",lib.GetAura({"Serenity"}))
		end,
		["Tiger Palm_nomax"] = function()
			if cfg.AltPower.max>cfg.AltPower.now then
				return lib.SimpleCDCheck("Tiger Palm",math.max(lib.GetAura({"Serenity"}),lib.Time2Power(cfg.Power.max)))
			end
			return nil
		end,
		["Blackout Kick"] = function()
			if lib.GetAura({"Serenity"})>lib.GetSpellCD("Blackout Kick") or lib.GetAura({"Blackout Kick!"})>lib.GetSpellCD("Blackout Kick") then
				return lib.SimpleCDCheck("Blackout Kick")
			else
				if cfg.cleave_targets>=3 and not cfg.noaoe then
					if cfg.AltPower.now>=3 then
						return lib.SimpleCDCheck("Blackout Kick",lib.GetAura({"Mark of the Crane"}))
					end
				else
					if cfg.AltPower.now>1 then
						return lib.SimpleCDCheck("Blackout Kick")
					end
				end
			end
			return nil
		end,
		["Blackout Kick_max"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then
				return lib.SimpleCDCheck("Blackout Kick")
			end
			return nil
		end,
		["Blackout Kick_aoe"] = function()
			if cfg.cleave_targets>=3 and cfg.AltPower.now==2 and lib.IsLastSpell("Tiger Palm") then
				return lib.SimpleCDCheck("Blackout Kick")
			end
			return nil
		end,
		["Chi Burst_aoe"] = function()
			if cfg.cleave_targets>=3 then
				if lib.IsLastSpell("Tiger Palm") then
					return lib.SimpleCDCheck("Chi Burst")
				end
				return nil
			else
				return lib.SimpleCDCheck("Chi Burst",lib.GetAura({"Serenity"}))
			end
		end,
		["Crackling Jade Thunderstorm"] = function()
			return lib.SimpleCDCheck("Crackling Jade Thunderstorm",lib.GetAura({"Serenity"}))
		end,
		["Chi-Wave_aoe"] = function()
			if cfg.cleave_targets>=3 then
				if lib.IsLastSpell("Tiger Palm") then
					return lib.SimpleCDCheck("Chi-Wave")
				end
				return nil
			else
				return lib.SimpleCDCheck("Chi-Wave",lib.GetAura({"Serenity"}))
			end
		end,
		["Flying Serpent Kick"] = function() --_aoe
			if cfg.cleave_targets>=3 then
				if lib.IsLastSpell("Tiger Palm") then
					return lib.SimpleCDCheck("Flying Serpent Kick")
				end
				return nil
			else
				return lib.SimpleCDCheck("Flying Serpent Kick",lib.GetAura({"Serenity"}))
			end
		end,
		
		["Rushing Jade Wind_Serenity"] = function()
			if lib.GetAura({"Serenity"})>lib.GetSpellCD("Rushing Jade Wind") then
				return lib.SimpleCDCheck("Rushing Jade Wind")
			end
			return nil
		end,
		["Rushing Jade Wind"] = function()
			if cfg.AltPower.now>1 or (cfg.cleave_targets>=3) then
				return lib.SimpleCDCheck("Rushing Jade Wind")
			end
			return nil
		end,
		["Storm, Earth, and Fire"] = function()
			return lib.SimpleCDCheck("Storm, Earth, and Fire",lib.GetAura({"Storm, Earth, and Fire"}))
		end,
	}
	
	lib.AddRangeCheck({
	{"Tiger Palm",nil},
	{"Crackling Jade Thunderstorm",{0,0,1,1}},
	})
	--cfg.mode = "dps"
	
	--cfg.spells_aoe={"Spin"}
	--cfg.spells_single={"Kick"}
	return true
end


lib.classpostload["MONK"] = function()
	cfg.healpercent=80
	lib.AddDispellPlayer("Detocs",{218164},{"Disease","Poison"}) --Detocs
	lib.NoSaveSpell("Detocs")
	lib.SetInterrupt("Kick",{116705}) --Spear Hand Strike
	lib.NoSaveSpell("Kick")
	
	--lib.AddSpell("Sphere",{124081},true) -- Zen Sphere
	--lib.AddAura("Sphere",124081,"buff","player") -- Zen Sphere
	cfg.case["Sphere_noSphere"] = function()
		return lib.SimpleCDCheck("Sphere",lib.GetAura({"Sphere"}))
	end
	
	lib.AddSpell("Xuen",{123904}) --Invoke Xuen, the White Tiger
	
	lib.AddSpell("Blackout Kick",{100784}) --Blackout Kick
	
	lib.AddSpell("Chi-Wave",{115098}) -- Chi-Wave
	cfg.case["Chi-Wave"] = function()
		return lib.SimpleCDCheck("Chi-Wave",lib.GetAura({"Serenity"}))
	end
	lib.AddSpell("Chi Burst",{123986})
	cfg.case["Chi Burst"] = function()
		return lib.SimpleCDCheck("Chi Burst",lib.GetAura({"Serenity"}))
	end
	
	lib.AddSpell("Touch of Death",{115080},true) -- Touch of Death
	

--	lib.AddSpell("LotWT",{116781}) -- Legacy of the White Tiger
--	lib.AddAura("LotWT",116781,"buff","player") -- Legacy of the White Tiger
--	lib.AddSpell("Fortifying",{115203}) -- Fortifying Brew
--	lib.AddAura("Fortifying",120954,"buff","player")
	
--	lib.AddSpell("Zen",{115176},true) -- Zen Meditation
	
	
	cfg.case["Fortifying"] = function()
		if not lib.hardtarget() then return nil end
		if lib.GetAura({"Touch of Death"})>0 then
			return lib.SimpleCDCheck("Fortifying")
		end
		return nil
	end
	
--[[	cfg.case["LotWT_nobuff"] = function()
		return lib.SimpleCDCheck("LotWT",math.min(lib.GetAuras("Stats"),lib.GetAuras("Crit")))
	end]]
	
	lib.AddAura("Power_Strikes",129914,"buff","player")
	--lib.AddSpell("Jab",{115693,115695,115687,115698,108557,100780})
	--lib.FixSpell("Jab","cost")
	--lib.AddSpell("Expel",{115072}) -- Expel Harm
	--lib.FixSpell("Expel","cost")

	cfg.case["Jab_aoe"] = function()
		if cfg.AltPower.max>=cfg.AltPower.now+cfg.chi_hit+lib.GetAuraStacks("Power_Strikes") and lib.GetSpellCD("Spin")>=lib.Time2Power(lib.GetSpellCost("Spin")+lib.GetSpellCost("Jab")) then
			return lib.SimpleCDCheck("Jab")
		end
		return nil
	end
	cfg.case["Expel_nomax"] = function()
		if cfg.AltPower.max>=cfg.AltPower.now+cfg.chi_hit+lib.GetAuraStacks("Power_Strikes") and lib.GetUnitHealth("player","percent")<=cfg.healpercent then
			return lib.SimpleCDCheck("Expel")
		end
		return nil
	end

	
	lib.CD = function()
		lib.CDadd("Kick")
		lib.CDadd("Detocs")
		lib.CDadd("Effuse")
		lib.CDAddCleave("Rushing Jade Wind",nil,148187)
		lib.CDAddCleave("Spinning Crane Kick",nil,107270)
		lib.CDAddCleave("Whirling Dragon Punch",nil,158221)
		lib.CDadd("Touch of Death")
		lib.CDadd("Serenity")
		lib.CDadd("Storm, Earth, and Fire")
		if cfg.spells["Xuen"] then
			lib.CDadd("Xuen")
			lib.CDaddTimers("Xuen","Xuen",function(self, event, unitID,spellname, rank, castid, spellID)
				if event=="UNIT_SPELLCAST_SUCCEEDED" and unitID=="player" and spellID==lib.GetSpellId("Xuen") then
					CooldownFrame_SetTimer(self.cooldown,GetTime(),45,1)
				end
			end
			,{"UNIT_SPELLCAST_SUCCEEDED"})
		end
		lib.CDadd("TB")
		lib.CDadd("Chi_Brew")
		lib.CDadd("Brew")
		lib.CDturnoff("Zen")
		lib.CDadd("Karma")
		lib.CDturnoff("Karma")
		lib.CDadd("Fortifying")
		lib.CDturnoff("Fortifying")
		lib.CDadd("Chi-Wave")
		lib.CDadd("Chi Burst")
		lib.CDadd("Sphere")
		lib.CDadd("Flying Serpent Kick")
		lib.CDadd("Crackling Jade Thunderstorm")
	end
end
end